# SubsidyListWindow Struct Reference

Inheritance diagram for SubsidyListWindow:

## Public Member Functions
| SubsidyListWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
void | HandleClick (const Subsidy *s)
virtual void | OnPaint ()
| The window must be repainted.
uint | CountLines ()
| Count the number of lines in this window.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.

## Detailed Description

Definition at line 33 of file subsidy_gui.cpp.

## Member Function Documentation

uint SubsidyListWindow::CountLines | ( |  | ) | `[inline]`

Count the number of lines in this window.

Returns:
  the number of lines

Definition at line 118 of file subsidy_gui.cpp.

References Subsidy::IsAwarded().

Referenced by OnInvalidateData().

virtual void SubsidyListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 153 of file subsidy_gui.cpp.

References _date, Subsidy::awarded, ConvertDateToYMD(), YearMonthDay::day, DrawString(), FONT_HEIGHT_NORMAL, Scrollbar::GetCapacity(), Scrollbar::GetPosition(), Subsidy::IsAwarded(), IsInsideMM(), Subsidy::remaining, SetDParam(), Window::vscroll, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

virtual void SubsidyListWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 40 of file subsidy_gui.cpp.

References Scrollbar::GetCapacity(), Scrollbar::GetPosition(), Subsidy::IsAwarded(), IsInsideMM(), Window::resize, ResizeInfo::step_height, Window::vscroll, and WD_FRAMERECT_TOP.

virtual void SubsidyListWindow::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 223 of file subsidy_gui.cpp.

References CountLines(), Scrollbar::SetCount(), and Window::vscroll.

virtual void SubsidyListWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 109 of file subsidy_gui.cpp.

References Window::DrawWidgets().

virtual void SubsidyListWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 218 of file subsidy_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and Window::vscroll.

virtual void SubsidyListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 140 of file subsidy_gui.cpp.

References GetStringBoundingBox(), maxdim(), WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

The documentation for this struct was generated from the following file:

- src/subsidy_gui.cpp